using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Web.Services;
using AjaxControlToolkit;
using System.Collections.Specialized;
using System.Data.SqlClient;
using System.Web.Script.Services;

public partial class _Default : System.Web.UI.Page {

    protected void Page_Load(object sender, EventArgs e) {
    }

    protected void ButtonSubmit_Click(object sender, EventArgs e) {
        if (!this.IsValid) return;

        this.LabelSelected.Text = "Selected location code: " + this.DropDownListRegion.SelectedValue;
    }

    [WebMethod]
    [ScriptMethod]
    public static CascadingDropDownNameValue[] GetCountries(string knownCategoryValues, string category) {
        if (category != "Country") return null;         // Invalid category requested
        return GetItems(null);                          // List all countries (locations with no parent)
    }

    [WebMethod]
    [ScriptMethod]
    public static CascadingDropDownNameValue[] GetRegions(string knownCategoryValues, string category) {
        if (category != "Region") return null;          // Invalid category requested
        StringDictionary kv = CascadingDropDown.ParseKnownCategoryValuesString(knownCategoryValues);
        if (!kv.ContainsKey("Country")) return null;    // No parent ctg (country) specified
        return GetItems(kv["Country"]);
    }

    private static CascadingDropDownNameValue[] GetItems(string pc) {
        string cs = ConfigurationManager.ConnectionStrings["Locations"].ConnectionString;
        string sql = "SET ANSI_NULLS OFF;SELECT Code, Name FROM Locations WHERE ParentCode=@ParentCode ORDER BY Name";

        using (DataTable dt = new DataTable()) {
            // List all locations with specified parent or without parent at all
            using (SqlConnection db = new SqlConnection(cs)) {
                db.Open();
                using (SqlCommand cmd = new SqlCommand(sql, db)) {
                    cmd.Parameters.Add("@ParentCode", SqlDbType.VarChar, 10).Value = DBNull.Value;
                    if (!string.IsNullOrEmpty(pc)) cmd.Parameters["@ParentCode"].Value = pc;
                    using (SqlDataAdapter da = new SqlDataAdapter(cmd)) da.Fill(dt);
                }
            }

            if (dt.Rows.Count == 0) {
                // No locations found
                return new CascadingDropDownNameValue[] { new CascadingDropDownNameValue("n/a", pc, true) };
            }
            else {
                // Convert DataTable to list of items
                CascadingDropDownNameValue[] r = new CascadingDropDownNameValue[dt.Rows.Count];
                for (int i = 0; i < dt.Rows.Count; i++) {
                    r[i] = new CascadingDropDownNameValue(dt.Rows[i]["Name"] as string, dt.Rows[i]["Code"] as string);
                }
                return r;
            }
        }
    }

}